<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.4.549">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>r7</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
/* CSS for citations */
div.csl-bib-body { }
div.csl-entry {
  clear: both;
  margin-bottom: 0em;
}
.hanging-indent div.csl-entry {
  margin-left:2em;
  text-indent:-2em;
}
div.csl-left-margin {
  min-width:2em;
  float:left;
}
div.csl-right-inline {
  margin-left:2em;
  padding-left:1em;
}
div.csl-indent {
  margin-left: 2em;
}</style>


<script src="r7_files/libs/clipboard/clipboard.min.js"></script>
<script src="r7_files/libs/quarto-html/quarto.js"></script>
<script src="r7_files/libs/quarto-html/popper.min.js"></script>
<script src="r7_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="r7_files/libs/quarto-html/anchor.min.js"></script>
<link href="r7_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="r7_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="r7_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="r7_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="r7_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">

  <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

<script type="text/javascript">
const typesetMath = (el) => {
  if (window.MathJax) {
    // MathJax Typeset
    window.MathJax.typeset([el]);
  } else if (window.katex) {
    // KaTeX Render
    var mathElements = el.getElementsByClassName("math");
    var macros = [];
    for (var i = 0; i < mathElements.length; i++) {
      var texText = mathElements[i].firstChild;
      if (mathElements[i].tagName == "SPAN") {
        window.katex.render(texText.data, mathElements[i], {
          displayMode: mathElements[i].classList.contains('display'),
          throwOnError: false,
          macros: macros,
          fleqn: false
        });
      }
    }
  }
}
window.Quarto = {
  typesetMath
};
</script>

</head>

<body class="fullcontent">

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">

<main class="content" id="quarto-document-content">




<div class="cell">
<style type="text/css">
.justify {
  text-align: justify !important
}
</style>
</div>
<section id="rekomendowane-metody-oceny-ryzyka-ujawnienia-danych-objętych-tajemnicą-statystyczną" class="level1">
<h1>Rekomendowane metody oceny ryzyka ujawnienia danych objętych tajemnicą statystyczną</h1>
<section id="dane-zagregowane" class="level2">
<h2 class="anchored" data-anchor-id="dane-zagregowane">Dane zagregowane</h2>
<div class="justify">
<p>Tablice statystyczne (a także ilustracje graficzne) zawierają agregaty danych obliczane na podstawie danych z&nbsp;badania reprezentacyjnego lub pełnego albo konglomeratu badania reprezentacyjnego i pełnego. Ponieważ w naliczaniu agregatów dla badań reprezentacyjnych istotną rolę odgrywają wagi dla poszczególnych rekordów wynikające z przyjętego schematu losowania z ewentualną kalibracją (dla obserwacji z badania pełnego przyjmujemy wagę równą 1), zatem w ocenie ryzyka ujawnienia należy wziąć pod uwagę następujące wymogi wynikające z Ustawy i ugruntowanej pragmatyki w zakresie kontroli ujawniania danych:</p>
<ul>
<li>liczba jednostek wchodzących w skład agregatu w populacji bądź jej oszacowanie musi wynosić co najmniej 3 (wymaganie dotyczące komórek, jeśli chodzi o liczbę szacowanej lub znanej liczby jednostek w&nbsp;populacji),</li>
<li>udział najwyższej spośród wartości jednostkowych cechy z próby wchodzących w skład agregatu w&nbsp;wartości oszacowania wielkości agregatu w populacji jest nie większy niż 75% (wymaganie dotyczące udziału wartości jednostkowych w wielkości sumarycznej).</li>
</ul>
<p>Agregat, który nie spełnia przynajmniej jednego z tych warunków uznawany jest za stwarzający zagrożenie identyfikacją konkretnej jednostki (czyli krótko mówiąc – ryzykowny). Powyższe warunki – wedle zapisów Ustawy – stosuje się przede wszystkim do danych charakteryzujących wyniki ekonomiczno-finansowe podmiotów gospodarki narodowej prowadzących działalność gospodarczą. Jednak w razie potrzeby można oprzeć się na nich także w przypadku danych z badań społecznych oraz spisów powszechnych, o ile określone dane uważa się za wrażliwe i o ile nie zastosowano już skuteczniejszych metod ochrony tajemnicy statystycznej.</p>
<p>Istnieje też wymaganie dotyczące próby. Jako ryzykowną należy mianowicie uznać sytuację, gdy w próbie występuje tylko jedna jednostka reprezentująca agregat lub występują dwie jednostki, których wagi uogólniające są identyczne lub różnią się o mniej niż 30% wielkości mniejszej z nich; warunek ten może być pominięty przy ocenie konieczności ukrywania przekrojów objętych tajemnicą statystyczną (możliwość nieukrywania przekrojów mimo wystąpienia powyższej sytuacji) jeżeli z prawdopodobieństwem graniczącym z&nbsp;pewnością można przyjąć, że liczba jednostek wchodzących w skład agregatu w populacji generalnej wynosi co najmniej 3.</p>
<p>Ocena ryzyka ujawnienia informacji wrażliwych zależy w największym stopniu od liczby komórek wrażliwych w&nbsp;tablicy, czyli takich, które nie spełniają przynajmniej jednego z powyższych warunków. Im większa liczba takich komórek, tym ryzyko wyższe. Ogólnie rzecz biorąc, prawdopodobieństwo wtórnej identyfikacji jednostki <span class="math inline">\(i\)</span> przynależnej do komórki <span class="math inline">\(C_l\)</span> wynosi <span class="math inline">\(1/F_l\)</span> (gdzie <span class="math inline">\(F_l\)</span> to liczba jednostek w populacji przynależących do tej komórki). Warto też zauważyć, że wymóg maksymalnego udziału nie większego niż 75% to w istocie zasada <em>(n,k)</em> dominacji przy <span class="math inline">\(n=1\)</span> i <span class="math inline">\(k=75\)</span>. <strong>Można tu zatem zastosować ocenę ryzyka zaproponowaną przez Domingo–Ferrera i Torrę <span class="citation" data-cites="domingo2004disclosure">(<a href="#ref-domingo2004disclosure" role="doc-biblioref">2004</a>)</span>, opartą na poziomie odchylenia sumy</strong> <strong><em>n</em></strong> <strong>największych udziałów w komórce od</strong> <strong><em>k%</em></strong>. Chodzi o umożliwienie eliminacji ryzyka tego, że w komórkach, w których różnice między udziałami są znaczne, możliwa precyzja oszacowania potencjalnej wielkości dla największego udziałowca przez udziałowca dalszego w kolejności może być bardzo duża. Zaproponowana metoda umożliwia znaczną redukcję tego ryzyka. Pozwala to też na zaostrzenie reguły <em>(n,k)</em> dominacji w razie potrzeby.</p>
<p>Obliczając ryzyko należy pamiętać także i o tym, że użytkownik może dysponować alternatywnymi źródłami danych, które – mimo opracowania przez statystykę publiczną tablicy według powyższych reguł – mogą pozwolić na identyfikację jednostki. Trzeba przy tym uwzględnić następujące kierunki ryzyka (zob. np. Hundepool i in. <span class="citation" data-cites="hundepool2012statistical">(<a href="#ref-hundepool2012statistical" role="doc-biblioref">2012</a>)</span>, Młodak i in. <span class="citation" data-cites="mlodak2023poufnosc">(<a href="#ref-mlodak2023poufnosc" role="doc-biblioref">2023</a>)</span>):</p>
<ul>
<li><p>ujawnienie atrybutu jednostki – dotyczy sytuacji, kiedy w pierwszej kolejności dochodzi do identyfikacji jednostki, czyli poprzez niewielkie wartości komórek w tablicy. Wartość komórki lub wartość brzegowa ma np. wartość 1 i na tej podstawie dochodzi do identyfikacji jednostki. Następnie poprzez inne publikacje oparte o to samo źródło danych uzyskane zostają dodatkowe informacje o zidentyfikowanej jednostce; na przykład: niech z jednej z tablic wynika, że w gminie wiejskiej mieszka tylko jedna uczennica danej szkoły, wówczas na podstawie tej informacji i danych z innej tablicy (np. struktury uczniów według miejsca zamieszkania, wieku, promocji do następnej klasy) można odczytać wiele wrażliwych informacji o niej.</p></li>
<li><p>ujawnienie atrybutu grupy – uzyskanie dodatkowych informacji o zidentyfikowanej grupie (to znaczy o grupie jednostek zdefiniowanej przez wspólną wartość określonej cechy (np. osoby w wieku 20-25 lat czy osoby mieszkające w określonej gminie) lub o tym, że zidentyfikowana grupa jakiegoś atrybutu nie posiada. Hundepool i in. <span class="citation" data-cites="hundepool2012statistical">(<a href="#ref-hundepool2012statistical" role="doc-biblioref">2012</a>)</span> wskazują, że jest to bardzo często zaniedbywany element ochrony informacji objętych tajemnicą statystyczną. Niebezpieczeństwo ujawnienia danych wrażliwych występuje w przypadkach, gdy wszystkie lub prawie wszystkie jednostki należą do jednej kategorii. Dla przykładu: jeżeli w pewnym obszarze jest 10 mężczyzn w wieku 65–70 lat, a wszyscy oni pracują w niepełnym wymiarze czasu pracy, to <em>de facto</em> następuje ujawnienie informacji o formie zatrudnienia wszystkich tych mężczyzn.</p></li>
<li><p>ujawnienie przez łączenie – poprzez relację łączącą dwie lub więcej tablic możliwe jest uzyskanie dodatkowej informacji. Analiza wspólnych zmiennych występujących w różnych tablicach stwarza możliwość uzyskania informacji identyfikującej jednostkę. Można tutaj wskazać trzy kierunki takiego łączenia:</p>
<ul>
<li>różnicowanie geograficzne: np. jeśli w jednym roku w pewnej gminie mieszkało 34 Ukraińców, a w następnym roku nastąpiło administracyjne powiększenie obszaru gminy, w wyniku czego opublikowano, że takich Ukraińców jest 35 (przy czym w ciągu tego roku żaden nie wyjechał ani nie zmarł, ani nie przybył z zagranicy), to wiadomo, że na dołączonym obszarze mieszka jeden Ukrainiec,</li>
<li>łączenie poprzez wspólne zmienne: wykorzystanie tych samych zmiennych występujących w dwóch lub więcej różnych tablicach do połączenia tych tablic i uzyskania informacji wrażliwych; dla przykładu, mamy 3 publikowane tablice (przykład inspirowany egzemplifikacją z książki Hundepool i in. <span class="citation" data-cites="hundepool2012statistical">(<a href="#ref-hundepool2012statistical" role="doc-biblioref">2012</a>)</span>)</li>
</ul>
<p><img src="fig/r7.1.png" class="img-fluid"></p>
<p><img src="fig/r7.2.png" class="img-fluid"></p>
<p><img src="fig/r7.3b.png" class="img-fluid"></p>
<p><img src="fig/r7.4.png" class="img-fluid"></p>
<ul>
<li>tablice subpopulacyjne: odnoszą się do wcześniej zdefiniowanej subpopulacji; na przykład liczba zachorowań na nowotwór gruczołu krokowego (prostaty) dotyczyć będzie z definicji tylko mężczyzn. Na przykład, jeżeli w jednej tablicy prezentowane są zachorowania na ten nowotwór w obszarze A w grupach wiekowych: do 40 lat, 40-45 lat, 45-50 lat, 50-55 lat, 55-60 lat, 60-65 lat, 65-70 lat, 70-75 lat, 75-80 lat, 80-85 lat oraz 85 i więcej lat, a w drugiej (być może zamieszczonej w innym źródle) w tym obszarze A w grupach: do 50 lat, 50-67 lat, 68-75 lat, 75-85 lat, 85-90 lat oraz 90 i więcej lat, to np. jeśli z pierwszej tablicy wynika, że na nowotwór prostaty chorowało 7 mężczyzn w wieku 50-55 lat, 9 – w wieku 55-60 lat, 10 – w wieku 60-65 lat i 8 w wieku 65-70 lat, a z drugiej tablicy wnioskujemy, że zachorowało 33 mężczyzn w wieku 50-67 lat, to można stąd wywnioskować, że na nowotwór prostaty cierpiał tylko jeden mężczyzna w wieku 67-70 lat.</li>
</ul></li>
</ul>
<p>W przypadku badań reprezentacyjnych indywidualne ryzyko ujawnienia i-tej jednostki w próbie definiowane jest jako prawdopodobieństwo wtórnej identyfikacji według najgorszego przypadku scenariusza (zgodnie z założeniami powyżej). Najgorszy scenariusz ujawnienia zaś to taki, w ramach którego łatwość dostępu do określonych źródeł danych (w statystyce publicznej lub poza nią) i posługiwanie się nimi stwarzają największe zagrożenie ujawnieniem informacji wrażliwych poprzez łączenie odpowiednich danych. Na przykład w przypadku Badania Aktywności Ekonomicznej Ludności stosunkowo najłatwiejszy dla potencjalnego użytkownika byłby dostęp do alternatywnych źródeł danych (opartych np. na rejestrze bezrobotnych, wyborców czy danych ze spisu powszechnego), a zatem połączenie takich informacji celem identyfikacji jednostki jest najbardziej prawdopodobne (nawet jeśli poszczególne zbiory – jak spisowy – byłyby chronione przez odpowiednie ingerencje w dane oryginalne). Inne źródła administracyjne, które mogłyby tutaj wchodzić w grę (np. rejestr podatkowy – POLTAX czy ewidencja ludności – PESEL) są zazwyczaj trudniej dostępne.</p>
<p>Ryzyko indywidualne wyznacza się tu według następującej reguły:</p>
<p><span class="math display">\[r_i=P(i \text{ jest poprawnie dopasowane do } i^*│s, \mathscr{P}, \text{ najgorszy możliwy scenariusz }),\]</span></p>
<p>gdzie <span class="math inline">\(\mathscr{P}\)</span> oznacza się populację, a <span class="math inline">\(s\)</span> – próbę z niej pobraną, która wraz z wagami wynikającymi ze schematu losowania (odpowiadającymi odwrotnościom prawdopodobieństw wylosowania jednostek do próby) ma zostać udostępniona. Z kolei <span class="math inline">\(i\)</span> to jednostka z próby, zaś <span class="math inline">\(i^*\)</span> – jednostka w populacji generalnej.</p>
<p>Ryzyko wtórnej identyfikacji (czyli ryzyko identyfikacji jednostki na podstawie wartości quasi identyfikatorów) określa się na poziomie obserwacji dla pojedynczej jednostki (obserwowanej w danych jednostkowych jako pojedynczy rekord). Oznaczmy przez <span class="math inline">\(F_j\)</span> liczbę jednostek w populacji, ale przez <span class="math inline">\(f_j\)</span> – liczbę jednostek w próbie przynależących do <span class="math inline">\(j\)</span>–tej komórki (gdzie <span class="math inline">\(j\)</span> jest liczbą naturalną). Miara globalnego ryzyka ujawnienia, na poziomie zbioru danych, oznaczana jako <span class="math inline">\(\tau_1\)</span>, to suma miar indywidualnego ryzyka ujawnienia dla wszystkich <span class="math inline">\(j\)</span>, dla których liczba jednostek w populacji jest dodatnia, czyli (zob. np. Hundepool i in. <span class="citation" data-cites="hundepool2012statistical">(<a href="#ref-hundepool2012statistical" role="doc-biblioref">2012</a>)</span>):</p>
<p><span id="eq-tau1"><span class="math display">\[\tau_1=\sum_{j:F_j&gt;0}\frac{1}{F_j} \tag{1}\]</span></span></p>
<p>Miarą ryzyka indywidualnego jest tutaj odwrotność liczby jednostek należących do danej komórki w populacji. W tym znaczeniu jest to prawdopodobieństwo zdarzenia polegającego na tym, że dana liczebność komórki w populacji pozwala na identyfikację (co najmniej jednej) jednostki. Jeżeli badanie ma charakter pełny, wówczas <span class="math inline">\(f_j=F_j\)</span> dla każdego <span class="math inline">\(j\)</span>. Gdy zaś badanie jest reprezentacyjne, wtedy <span class="math inline">\(F_j\)</span> szacuje się np. jako sumę wynikających z zastosowanego w badaniu schematu losowania wag dla jednostek wylosowanych do próby i należących do <span class="math inline">\(j\)</span>-tej komórki tablicy. Takie określenie ryzyka wynika z faktu, że w jego ocenie należy wziąć pod uwagę możliwość identyfikacji jednostki zarówno na podstawie danych jednostkowych, jak też na podstawie danych dla populacji.</p>
<p>Ponieważ wartości unikalne w populacji generalnej (czyli takie, dla których <span class="math inline">\(F_j=1\)</span>) są przeważającym czynnikiem ryzyka ujawnienia, uwagę należy skupić na wartościach unikalnych w próbie (tzn. tych, dla których <span class="math inline">\(f_j=1\)</span>). Stąd często ogranicza się wyznaczanie miary ryzyka do komórek, do których w próbie należą jednostki unikalne (a więc takie, że odpowiadające im kombinacje wartości zmiennych definiujących komórkę, występują w tej komórce tylko jedno– lub dwukrotnie, co jest także zgodne z zapisami Ustawy).</p>
<p>Biorąc powyższe pod uwagę, oczekiwaną wartość trafnych odgadnięć, w przypadku gdy każda jednostka unikalna z próby jest dopasowana do jednostki wybranej losowo z tej samej komórki dla populacji (bez względu na zastosowany schemat losowania), zapisuje się następująco:</p>
<p><span id="eq-tau2"><span class="math display">\[\tau_2=\sum_{j}I(f_j=1)\frac{1}{F_j}, \tag{2}\]</span></span></p>
<p>lub (z uwagi na polskie uregulowania):</p>
<p><span id="eq-tau3"><span class="math display">\[\tau^{*}_2=\sum_{j}\left(I(f_j=1)\frac{1}{F_j}+I(f_j=2)\frac{1}{F_j}\right), \tag{3}\]</span></span></p>
<p>gdzie <span class="math inline">\(I(∙)\)</span> pojawiające się w powyższym wzorze to funkcja indykatorowa, przyjmująca wartość jeden, gdy spełnione jest dane kryterium lub zero w przeciwnym przypadku. Innymi słowy, jest to suma <a href="#eq-tau1" class="quarto-xref">Equation&nbsp;1</a> obcięta tylko do komórek, których liczebność w próbie jest równa 1 (<a href="#eq-tau2" class="quarto-xref">Equation&nbsp;2</a>) albo nie większa od 2 (<a href="#eq-tau3" class="quarto-xref">Equation&nbsp;3</a>). Zauważmy, że nie jest tu już potrzebne założenie, że <span class="math inline">\(F_j&gt;0\)</span>, gdyż warunek ten wynika wprost z niezerowej liczebności w próbie.<br>
Alternatywną definicją rozpatrywanej miary ryzyka jest liczba unikalnych jednostek w próbie <span class="math inline">\((f_j=1)\)</span>, które są jednocześnie unikalne w przypadku populacji generalnej <span class="math inline">\((F_j=1)\)</span>:</p>
<p><span id="eq-tau4"><span class="math display">\[\tau_2=\sum_{j}I(f_j=1,F_j=1) \tag{4}\]</span></span></p>
<p>Powyższe miary można przedstawić w postaci wskaźników. Wtedy wielkości <span class="math inline">\(\tau_1\)</span>, <span class="math inline">\(\tau_2^{*}\)</span> i <span class="math inline">\(\tau_3\)</span> należy podzielić przez rozmiar próby lub liczbę unikalnych jednostek w próbie. Mierniki takie wyznaczane są np. w programie <span class="math inline">\(\tau\)</span>–Argus czy pakiecie sdcTable środowiska R i okazują się wygodne w stosowaniu. <strong>Można zatem rekomendować stosowanie tych miar w praktyce statystycznej.</strong></p>
<section id="dane-jednostkowe" class="level2">
<h2 class="anchored" data-anchor-id="dane-jednostkowe">Dane jednostkowe</h2>
<p>W przypadku danych jednostkowych nieidentyfikowalnych metody oceny ryzyka ujawnienia ściśle wiążą się z rodzajem skali pomiarowej, na jakiej mierzone są dane z zakresu poszczególnych zmiennych. Inne miary w tym zakresie przeznaczone są bowiem dla zmiennych kategorialnych (tzn. wyrażonych na skali nominalnej lub porządkowej), a inne dla zmiennych ciągłych (czyli wyrażonych na skalach: różnicowej lub ilorazowej).</p>
<p>W przypadku danych kategorialnych podstawą konstrukcji miar ryzyka są częstości występowania poszczególnych możliwych kombinacji wartości takich cech. <strong>Określa się zatem minimalną częstość występowania danej kombinacji stanowiącą warunek konieczny ochrony przed identyfikacją jednostki (zasada</strong> <strong><em>k</em></strong> <strong>– anonimowości). W polskiej rzeczywistości prawnej będzie to 3 (lub więcej, w razie potrzeby)</strong>. Z tym wiąże się też sposób traktowania braków danych. Templ <span class="citation" data-cites="templ2017statistical">(<a href="#ref-templ2017statistical" role="doc-biblioref">2017</a>)</span> podaje, że występuje pięć sposobów:</p>
<ul>
<li>sposób klasyczny: braki danych zwiększają częstości wszystkich kombinacji, których mogą dotyczyć (brak danych traktuje się jak każdą możliwą wartość),</li>
<li>sposób konserwatywny: brakujące wartości nie zwiększają częstości wszystkich kombinacji, których mogą dotyczyć, ale jedynie tych, w których braki te występują (brak danych traktuje się jako odrębną kategorię),</li>
<li>sposób kategorialny: brakujące wartości danych zwiększają częstości wszystkich kombinacji, których mogą dotyczyć o ustaloną stałą <span class="math inline">\(c\)</span>,</li>
<li>sposób skrajnie konserwatywny: brakujące wartości nie zwiększają częstości żadnych kombinacji (braki danych nie są traktowane tożsamo),</li>
<li>sposób własnokategorialny: brakujące wartości nie zwiększają częstości żadnych kombinacji, jednak braki te traktowane są jako odrębna kategoria.</li>
</ul>
<p>Tablica 4 pokazuje przykład praktycznej realizacji tych sposobów dla trzech zmiennych kategorialnych i 10 rekordów:</p>
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><img src="fig/r7.4.png" class="img-fluid quarto-figure quarto-figure-center figure-img"></p>
</figure>
</div>
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><img src="fig/r7.4b.png" class="img-fluid quarto-figure quarto-figure-center figure-img"></p>
</figure>
</div>
<p>Wydaje się, że zastosowanie sposobu klasycznego może prowadzić do niedoszacowania faktycznego ryzyka ujawnienia (np. kombinacje z brakami danych zwiększą częstość unikatowych kombinacji pełnych), co istotnie zwiększa zagrożenie identyfikacji jednostki. Z kolei podejście skrajnie konserwatywne czy opcja własnokategorialna mogą powodować przeszacowywanie ryzyka (nadmiar kategorii unikatowych w kombinacjach z brakami danych). Dlatego też można polecić do stosowania przede wszystkim sposób konserwatywny, względnie kategorialny (gdy na podstawie wcześniejszych doświadczeń i płynącej z niej oceny poziomów i kierunków typowych braków danych) można określić typową lub przeciętną wartość stałej <span class="math inline">\(c\)</span>).</p>
<p>Z uwagi na to, że użytkownik może dysponować alternatywnymi źródłami danych z określonego zakresu, stosując kontrolę ujawniania danych należy wziąć pod uwagę potencjalne zbiory, do jakich teoretycznie może mieć dostęp użytkownik – np. jeśli pracuje on w instytucji zajmującej się prowadzeniem ewidencji ludności lub analizami demograficznymi, to może mieć on dostęp do rejestru PESEL i zawartych w nim informacji. Wtedy ryzyko ujawnienia trzeba oceniać w powiązaniu z tym źródłem. Innymi słowy, poziom ryzyka wynikającego z czystej konstrukcji tablicy należy powiększyć o ryzyko wynikające z unikatowości określonych wielkości w potencjalnie używanym przez użytkownika zbiorze alternatywnym. Warto podkreślić, że takie rozpoznanie ma na celu przede wszystkim uwzględnienie rzeczonej możliwości w (wewnętrznej) ocenie ryzyka ujawnienia a nie określenie zakresu danych udostępnianych użytkownikowi. Nie można jednak wykluczyć, że wywrze to wpływ na ostateczne decyzje w zakresie dostępu do danych, które jednak zawsze muszą mieć indywidualny charakter.</p>
<p><strong>Wobec powyższego, do określenia faktycznego poziomu ryzyka ujawnienia stosuje się często mocniejszą regułę</strong> <strong><em>l</em></strong> <strong>– różnorodności</strong>. Wymaga to wyodrębnienia zestawu zmiennych kluczowych (które w największym stopniu wpływają na ryzyko identyfikacji jednostki) i zmiennych wrażliwych niebędących kluczowymi (te zazwyczaj są poddawane post–randomizacji). W stosunku do zmiennych kluczowych stosuje się wówczas klasyczną regułę <em>k</em>–anonimowości, a następnie bada czy każda kombinacja tych zmiennych zawiera przynajmniej <em>l</em> wartości zmiennej wrażliwej o odpowiednio wysokiej częstości (wynikającej z obowiązujących regulacji prawnych – np. co najmniej 3 w Polsce – lub z doświadczenia). To dodatkowe sprawdzenie jest konieczne, jako że – jak już wcześniej zauważono – samo stosowanie zasady <em>k</em>-anonimowości może prowadzić do tworzenia grup niezróżnicowanych pod kątem wrażliwych atrybutów oraz z powodu niedostateczności ochrony samą zasadą <em>k</em>-anonimowości przed identyfikacją jednostki prostymi metodami (np. poprzez wiązanie tablic). Więcej na ten temat piszą np. Machanavajjhala i in. <span class="citation" data-cites="machanavajjhala2007diversity">(<a href="#ref-machanavajjhala2007diversity" role="doc-biblioref">2007</a>)</span>. Stosując zatem regułę <em>l</em>–różnorodności można wyznaczyć opisowe statystyki zróżnicowania wyrażonego liczbą różnych wartości zmiennej wrażliwej obserwowanych dla poszczególnych kombinacji wartości zmiennych kluczowych.</p>
<p><strong>W przypadku badania reprezentacyjnego, w ocenie ryzyka należy uwzględnić również wagi wynikające ze schematu losowania, pozwalające na oszacowanie częstości występowania poszczególnych kombinacji w populacji.</strong> Programy komputerowe, takie jak np. pakiet sdcMicro środowiska R, podają wtedy częstości występowania poszczególnych kombinacji zarówno w próbie, jak i w populacji. Jeżeli niektóre zmienne pozyskiwane są w sposób pełny (np. ze źródeł administracyjnych), to można też porównać populacyjne częstości kombinacji wartości tych zmiennych z odpowiednimi oszacowaniami. Oczywiście nawet niebezpieczne kombinacje wartości (czyli o częstości niższej niż arbitralnie ustalony próg) nie muszą stwarzać jednakowego ryzyka identyfikacji jednostki. Różnice te wynikają m.in. z faktu, że podzbiory wartości należących do kombinacji niebezpiecznej same są kombinacjami (choć mniejszego rozmiaru), mogą zatem być kombinacjami niebezpiecznymi lub nie. Dlatego też stworzono pojęcie minimalnej kombinacji unikatowej (ang. <em>Minimal Sample Unique, MSU</em>), czyli kombinacji niebezpiecznej, której żaden podzbiór właściwy nie stanowi kombinacji niebezpiecznej. Na przykład, taką kombinacją może być kombinacja (1,2,5), której częstość wynosi 1, podczas gdy częstości podkombinacji są następujące (1,2) – 5, (2,5) – 4, (1,5) – 7, {1} – 10 , {2} – 8 i {5} – 7. <strong>Ocenę ryzyka z uwzględnieniem MSU umożliwia specjalny algorytm wykrywania kombinacji unikalnych (ang.</strong> <strong><em>Special Uniques Detection Algorithm, SUDA)</em></strong>, oparty na założeniach, że im mniejsza jest liczba zmiennych należących do MSU lub im większa jest liczba MSU zawartych w rozpatrywanej kombinacji, tym ryzyko ujawnienia jest większe.</p>
<p>W efekcie otrzymujemy wykaz zmiennych wraz z ich <strong>ważnościami</strong>. Ważność zmiennej określa się zaś jako wkład do ryzyka ujawnienia, a konkretnie – to jak często kategoria danej zmiennej stanowi wkład do wyniku dla MSU (tzw. współczynnik <em>score for MSU</em>). Innymi słowy, bazuje to na liczbie minimalnych kombinacji unikatowych, które zawierają jakąkolwiek kategorię danej zmiennej. Szerzej pisze o tym np. Templ <span class="citation" data-cites="templ2017statistical">(<a href="#ref-templ2017statistical" role="doc-biblioref">2017</a>)</span>.</p>
<p>Algorytm SUDA <strong>dostępny</strong> jest m.in. w pakiecie sdcMicro środowiska R. Szczegóły na temat algorytmu SUDA podają np. Elliott, Manning i Ford <span class="citation" data-cites="elliot2002computational">(<a href="#ref-elliot2002computational" role="doc-biblioref">2002</a>)</span>. <strong>Algorytm ten można polecić do stosowania.</strong></p>
<p>Istotną rolę w efektywnym przebiegu procesu kontroli ujawniania danych odgrywa ocena ryzyka indywidualnego dla każdego rekordu. Ryzyko to odnosi się do częstości występowania kombinacji wartości zmiennych kluczowych z danego rekordu w rozpatrywanym zbiorze danych. Stanowi jedną z fundamentalnych miar ryzyka i jest użyteczne zazwyczaj w każdym przypadku, ale szczególnie – dla danych z badania reprezentacyjnego. Wartości miary należą do przedziału [0,1]. Im większa wartość miary, tym większe ryzyko. Algorytm prowadzący do jego wyznaczenia bazuje bowiem na modelu nadpopulacyjnym, w którym częstości w populacji szacowane są według przyjętego arbitralnie rozkładu teoretycznego. Najczęściej stosowany jest tutaj model Benedettiego–Franconi, w którym zakłada się, że częstości z próby mają rozkład Poissona z parametrem <span class="math inline">\(\lambda=N\pi_k\)</span>, gdzie <span class="math inline">\(N\)</span> to liczba jednostek w populacji, <span class="math inline">\(\pi_k\)</span> – prawdopodobieństwo wylosowania do próby jednostki z daną kombinacją wartości zmiennych kategorialnych. Częstość kombinacji owych wartości w populacji warunkowana odpowiednią częstością w próbie posiada zaś w tym przypadku ujemny rozkład dwumianowy <span class="math inline">\(-b(p_j,f_j)\)</span> z prawdopodobieństwem sukcesu będącym szacunkiem ilorazu częstości w próbie i szacowanej częstości w populacji <span class="math inline">\((p_j=f_j/F ̂_j)\)</span> oraz z liczbą sukcesów równą rzeczonej częstości w próbie <span class="math inline">\((f_j)\)</span>. Szczegóły na ten temat podają np. Templ <span class="citation" data-cites="templ2017statistical">(<a href="#ref-templ2017statistical" role="doc-biblioref">2017</a>)</span> czy Franconi i Polettini <span class="citation" data-cites="franconi2004individual">(<a href="#ref-franconi2004individual" role="doc-biblioref">2004</a>)</span>. Ryzyko indywidualne jest w ten sposób wyznaczane np. w programie <span class="math inline">\(\mu\)</span>–Argus i pakiecie sdcMicro środowiska R. Warto tę metodę polecić do praktycznego wykorzystania. W przypadku gdy w danych występuje określona hierarchia jednostek i ich agregatów, ryzyko dla takiego agregatu (np. gospodarstwa domowego gdy jednostkami są osoby) wyznaczane jest na podstawie wzoru: <span class="math inline">\(r_A=1-\Pi_{i:i\in A}(1-r_i)\)</span>, gdzie <span class="math inline">\(A\)</span> to dany agregat, zaś <span class="math inline">\(r_i\)</span> – ryzyko indywidualne dla <span class="math inline">\(i\)</span>–tej jednostki. Oznacza to, że opiera się ono na iloczynie prawdopodobieństw, że kombinacje wchodzące w skład danego agregatu są bezpieczne z punktu widzenia ochrony danych wrażliwych. Zakres wartości i interpretacja miary ryzyka hierarchicznego jest analogiczna jak w przypadku ryzyka indywidualnego. <strong>Ocena ryzyka indywidualnego (w tym hierarchicznego, jeśli hierarchia występuje) powinna stać się fundamentem działań w zakresie SDC.</strong> Ryzyko takie należy oceniać w każdych badaniach, w których występują zmienne kategorialne, a jeżeli mamy tam i hierarchie (np. jednostek przestrzennych, podmiotów według PKD, osoba-gospodarstwo domowe, itp.), to również ryzyko hierarchiczne.</p>
<p><strong>Nie mniej ważna jest także ocena ryzyka globalnego.</strong> Otrzymujemy tutaj jedną kompleksową miarę ryzyka dla całego zbioru. Możliwe są tutaj trzy alternatywne podejścia:</p>
<ul>
<li>oczekiwana liczba reidentyfikacji (suma ryzyk indywidualnych dla poszczególnych rekordów),</li>
<li>modele logarytmiczno-liniowe (bazujące na szacowaniu liczby unikatowych kombinacji w próbie, które są jednocześnie unikatowymi w populacji),</li>
<li>podejście benchmarkowe (oparte na liczbie obserwacji o indywidualnym poziomie ryzyka wyższym niż arbitralnie ustalony próg; próg ten ustala osoba dokonująca ochrony danych w oparciu o własności danego badania i zgromadzonych w nim informacji wynikowych, w tym rozmiaru i struktury danych, schematu doboru próby oraz cech jednostek; na przykład jeśli próba będzie mała a badanie obejmuje znaczną liczbę zmiennych kategorialnych o różnorodnych kategoriach, to rzeczony próg powinien być przyjęty na znacznie niższym poziomie aniżeli w przypadku badania bazującego na próbie dużego rozmiaru ze stosunkowo niezbyt znaczną liczbą zmiennych kategorialnych o małej liczbie kategorii).</li>
</ul>
<p>Szczegółowo metody te opisuje np. Templ <span class="citation" data-cites="templ2017statistical">(<a href="#ref-templ2017statistical" role="doc-biblioref">2017</a>)</span>. W pakiecie sdcMicro stosowane jest pierwsze podejście, czyli oczekiwana liczba reidentyfikacji. Podobnie rzecz się ma w przypadku programu <span class="math inline">\(\mu\)</span>–Argus, przy czym tam suma ryzyk indywidualnych dzielona jest przez liczbę rekordów.</p>
<p>Powyższe uwagi i sugestie dotyczą zmiennych kategorialnych. Jednak pozostaje jeszcze kwestia wyznaczania poziomu ryzyka ujawnienia dla zmiennych ciągłych, które posiadają swoją własną specyfikę, związaną zwłaszcza z teoretyczną możliwością przyjmowania nieskończonej liczby różnych wartości, na których w dodatku można wykonywać określone działania arytmetyczne. Tym samym nie mogą być tutaj zastosowane miary ryzyka oparte na częstościach (o ile zmienne te nie będą udostępniane w postaci skategoryzowanej, np. poprzez częstości jednostek, dla których wartości takiej zmiennej należą do określonych przedziałów). Wskaźniki dla tego typu zmiennych muszą być zatem innego rodzaju. W tym względzie pakiet sdcMicro środowiska R jako miarę ryzyka wykorzystuje odsetek obserwacji należących do przedziału, którego środkiem jest zakłócona w procesie SDC wartość, podczas gdy jego górna granica zdefiniowana została jako najgorszy możliwy scenariusz gdy użytkownik jest pewien, że każdy rekord ze zbioru oryginalnego najbliższy odpowiedniemu rekordowi w drugim (czyli zaburzonym) zbiorze jest faktycznie tożsamy z tym rekordem. Szerzej na ten temat piszą m.in. Mateo–Sanz i in. <span class="citation" data-cites="mateo2004outlier">(<a href="#ref-mateo2004outlier" role="doc-biblioref">2004</a>)</span>. Program <span class="math inline">\(\mu\)</span>-Argus nie posiada oddzielnych miar ryzyka ujawnienia dla zmiennych ciągłych, ale ryzyko to można oszacować np. kategoryzując zmienne rozpatrywanego typu.</p>
<p>Jak wynika z powyższych informacji, problemem jest brak uniwersalnej miary ryzyka dla całego zbioru, zawierającego zarówno zmienne kategorialne, jak i zmienne ciągłe. Jednak można by rozważyć możliwość skonstruowania takiej miary w oparciu o metodę wiązania rekordów opartej na odległości (zob. np. Pagliuca i Seri <span class="citation" data-cites="pagliuca1999some">(<a href="#ref-pagliuca1999some" role="doc-biblioref">1999</a>)</span>). Dla każdego rekordu w zbiorze po zastosowaniu SDC obliczamy odległość od każdego rekordu ze zbioru oryginalnego i na tej podstawie wskazujemy najbliższego i drugiego co do bliskości sąsiadów. Jeśli rekord ze zbioru po SDC i rekord jemu najbliższy ze zbioru oryginalnego odnoszą się do tej samej jednostki, to uznajemy je za powiązane bezpośrednio. Podobnie jeśli do tej samej jednostki odnoszą się: rekord ze zbioru zniekształconego i drugi najbliższy mu rekord ze zbioru oryginalnego, wtedy mówimy, że występuje między nimi powiązanie drugiego stopnia. Finalną miarę ryzyka stanowi odsetek rekordów ze zbioru po SDC, dla których występuje powiązanie bezpośrednie lub powiązanie drugiego stopnia.</p>
<p>Inną propozycję zawiera praca Młodaka, Pietrzaka i Józefowskiego <span class="citation" data-cites="mlodak2022trade">(<a href="#ref-mlodak2022trade" role="doc-biblioref">2022</a>)</span>. Wychodzi ona z założenia, że – ogólnie rzecz biorąc – można wyróżnić dwa rodzaje ryzyka ujawnienia informacji wrażliwych w zbiorze danych powstałym w efekcie zastosowania procesu SDC:</p>
<ul>
<li>ryzyko wewnętrzne – gdy występuje groźba ujawnienia informacji wrażliwych tylko w oparciu o zmodyfikowane dane (warto zauważyć, że miary ryzyka wewnętrznego mogą też być w sposób oczywisty użyte do oceny ryzyka ujawnienia przed zastosowaniem SDC),</li>
<li>ryzyko zewnętrzne – jeżeli występuje zagrożenie identyfikacji jednostki poprzez powiązanie danych udostępnionych po przeprowadzeniu procesu SDC z informacjami pochodzącymi z innych źródeł, do których użytkownik potencjalnie może mieć dostęp.</li>
</ul>
<p>Ryzyko wewnętrzne wynika – jak już wcześniej wskazywaliśmy – z faktu występowania jednoznacznych kombinacji wartości (dokładnie dla zmiennych kategorialnych oraz – jeśli dotyczy – w obrębie pewnego przedziału precyzji dla zmiennych ciągłych). Odnosi się ono do zagrożenia identyfikacją jednostki tylko przy użyciu informacji zawartych w udostępnianym zbiorze. W tym przypadku przyjmuje się, że użytkownik może opierać się jedynie na informacji, którą statystyka publiczna mu udostępnia.</p>
<p>Z kolei ryzyko zewnętrzne zależy od możliwości powiązania rekordów zawartych w zbiorze danych statystycznych (poddanemu procesowi SDC) z odpowiednimi rekordami z innych źródeł danych dostępnych użytkownikowi. Odnosi się ono zatem do sytuacji, w której użytkownik może sięgnąć do alternatywnych źródeł danych w celu identyfikacji jednostki poprzez połączenie odpowiednich rekordów z wszystkich tych zasobów.</p>
<p>Autorzy wskazanej wyżej pracy zaproponowali połączenie obu typów ryzyka ujawnienia oraz sposób kompleksowego pomiaru ryzyka zewnętrznego uwzględniającego zmienne, których dane wyrażone są na różnych skalach pomiarowych. Idea tej metody wywodzi się z koncepcji odległości Gowera.</p>
<p>Podsumowując, konieczne jest wyznaczenie ryzyka indywidualnego i globalnego (a w razie potrzeby także i hierarchicznego) dla zmiennych kategorialnych, ryzyka dla zmiennych ciągłych, a w miarę możliwości także określenie ważności poszczególnych zmiennych z punktu widzenia ich wpływu na wielkość ryzyka.</p>
<p>Na zakończenie należy zauważyć, że ocena ryzyka identyfikacji jednostki może być przeprowadzona w następujących fazach schematu GSBPM (MPPS):</p>
<ul>
<li>Projektowanie</li>
<li>Przetwarzanie i analiza</li>
<li>Ocena.</li>
</ul>
<p>Na etapie projektowania badania ryzyko ujawnienia może być szacowane w zasadzie wyłącznie na podstawie jego zasad metodologicznych bądź doświadczeń wyniesionych z wcześniejszych jego edycji (jeśli takie były). W pozostałych dwóch fazach oceny ryzyka dokonuje się już w oparciu o zgromadzone informacje, przed i po ich poddaniu kontroli ujawniania. Zgodnie z Polityką postępowania z danymi statystycznymi zaleca się, aby wybór metody bądź metod kontroli ujawniania danych był poprzedzony oceną ryzyka ujawnienia informacji poufnych z jednoczesną oceną ponoszonej straty informacji.</p>
</section>
</div>
</section>
</section>
<section id="bibliography" class="level1 unnumbered">


</section>

<div id="quarto-appendix" class="default"><section class="quarto-appendix-contents" role="doc-bibliography" id="quarto-bibliography"><h2 class="anchored quarto-appendix-heading">Bibliografia</h2><div id="refs" class="references csl-bib-body hanging-indent" data-entry-spacing="0" data-line-spacing="2" role="list">
<div id="ref-domingo2004disclosure" class="csl-entry" role="listitem">
Domingo-Ferrer, J., &amp; Torra, V. (2004). Disclosure risk assessment in statistical data protection. <em>Journal of Computational and Applied Mathematics</em>, <em>164</em>, 285–293.
</div>
<div id="ref-elliot2002computational" class="csl-entry" role="listitem">
Elliot, M. J., Manning, A. M., &amp; Ford, R. W. (2002). A computational algorithm for handling the special uniques problem. <em>International Journal of Uncertainty, Fuzziness and Knowledge-Based Systems</em>, <em>10</em>(05), 493–509.
</div>
<div id="ref-franconi2004individual" class="csl-entry" role="listitem">
Franconi, L., &amp; Polettini, S. (2004). Individual risk estimation in <span class="math inline">\(\mu\)</span>-argus: A review. <em>Privacy in Statistical Databases: CASC Project Final Conference, PSD 2004, Barcelona, Spain, June 9-11, 2004. Proceedings</em>, 262–272.
</div>
<div id="ref-hundepool2012statistical" class="csl-entry" role="listitem">
Hundepool, A., Domingo-Ferrer, J., Franconi, L., Giessing, S., Nordholt, E. S., Spicer, K., &amp; De Wolf, P.-P. (2012). <em>Statistical disclosure control</em>. John Wiley &amp; Sons.
</div>
<div id="ref-machanavajjhala2007diversity" class="csl-entry" role="listitem">
Machanavajjhala, A., Kifer, D., Gehrke, J., &amp; Venkitasubramaniam, M. (2007). L-diversity: Privacy beyond k-anonymity. <em>Acm Transactions on Knowledge Discovery from Data (Tkdd)</em>, <em>1</em>(1), 3–es.
</div>
<div id="ref-mateo2004outlier" class="csl-entry" role="listitem">
Mateo-Sanz, J. M., Sebé, F., &amp; Domingo-Ferrer, J. (2004). Outlier protection in continuous microdata masking. <em>International Workshop on Privacy in Statistical Databases</em>, 201–215.
</div>
<div id="ref-mlodak2022trade" class="csl-entry" role="listitem">
Młodak, A., Pietrzak, M., &amp; Józefowski, T. (2022). The trade-off between the risk of disclosure and data utility in SDC: A case of data from a survey of accidents at work 1. <em>Statistical Journal of the IAOS</em>, <em>38</em>(4), 1503–1511.
</div>
<div id="ref-mlodak2023poufnosc" class="csl-entry" role="listitem">
Młodak, A., Pietrzak, M., Klimanek, T., Józefowski, T., &amp; Lańduch, P. (2023). <em>Poufno<span>ś</span><span>ć</span> a u<span>ż</span>yteczno<span>ś</span><span>ć</span> informacji statystycznych. Dylematy ochrony udost<span>ę</span>pnianych danych</em>. Wydawnictwo Uniwersytetu Ekonomicznego w Poznaniu.
</div>
<div id="ref-pagliuca1999some" class="csl-entry" role="listitem">
Pagliuca, D., &amp; Seri, G. (1999). Some results of individual ranking method on the system of enterprise accounts annual survey. <em>Esprit SDC Project, Deliverable MI-3 D</em>, <em>2</em>, 1999.
</div>
<div id="ref-templ2017statistical" class="csl-entry" role="listitem">
Templ, M. (2017). Statistical disclosure control for microdata. <em>Cham: Springer</em>.
</div>
</div></section></div></main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    text: function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->




</body></html>